Ubuntu и старые ATI видеокарты (+ немного про BURG)

в 9:44, , рубрики: Без рубрики

История моя будет полезна тем кто имеет старую видеокарту от ATI, и хочет себе более лучшую графическую производительность нежели предоставляет стандартный mesa драйвер, ну и MonoDevelop-4(небольшое хобби). Увы но с дистрибутивом линукса я могу только зайти до жамканья пакетов, остальное для меня дремучий лес.
Прошу строго не судить так как это моя первая статья, и предназначен он для обычных начинающих пользователей, которые возможно слабо знакомы с Linux системами. А тем кто постарше и разбирается, предлагаю почитать, посмеяться над весьма спонтанными и не всегда корректными решениями.

Акт I. Я и Броненосец Майя (Linux Mint Maya)

О проблемах с видео картой я знал, знал о некоторых условиях их успешной установки, поэтому для установки была выбрана Linux Mint Maya, так как она основана на Ubuntu 12.04LTS, и как оказалось мой выбор был неплох. Но почему именно старый дистрибутив? AMD решили не поддерживать старые видеокарты под Unix системами, и поэтому приходится вертеться и крутиться чтоб работало шустро и красиво. А так приходится выбирать чтото одно. Но это меня не удовлетворяло. Поэтому начались поиски нужного в интернете и были вполне успешны, был найден репозиторий со всем нужным инструментарием, вообщем трудозатраты сводились к минимуму.

Итак, начнём… Требования для драйвера:

— Xserver <1.13 (в репозитории есть 1.12.4)
— Xorg <=6.9
— ядро <=3.4 (хотя пишут что есть фикс для 3.8)

Как узнать что система удовлетворяет нашим требованиям:

X -version узнаём версию Xserver и теоретически ядра
uname -r покажет нам версию ядра
aptitude show xserver-xorg версия Xorg (нагуглено, как сделать, проще не знаю)

В итоге на скачанном и установленном дистрибутиве мы имеем Xserver 1.11.3, Xorg 7.6 и ядро 3.2.0. По требованиям почти подходит, но была не была, решил поставить. Добавляем репозиторий:

sudo add-apt-repository ppa:makson96/fglrx
sudo apt-get update

Репозиторий установился, ключ стал, ну и отлично, теперь обновляем список доступных пакетов в репозитории и устанавливаем пакет fglrx-legacy, вариантов его установить много, я делал через apt-get:

sudo apt-get install fglrx-legacy

Всё стало. Перезагрузка и вот, оно работает, причём весьма неплохо. Тест на шестернях(glxgears) показал по ~800 FPS.
Обновлять X-сы не стал, так-как все работало нормально.
Но радость моя была скоротечной… Установленная из репозиториев monodevelop была всего лишь 2ой версии, и свежий аддончик с MonoGame в неё невстал. Я был расстроен, но не сдавался, были найдены репозитории дебиана на яндексе, был также найден сайт с описанием пакетов дебиана. В sources.list (/etc/apt/) была добавлена строка

deb http://mirror.yandex.ru/debian/ stable main contrib non-free

При обновлении списков доступных пакетов apt-get сказал что не нашел пару ключей. Ключи были скачаны с серверов убнты командой:

sudo apt-key adv --recv-keys --keyserver keyserver.ububntu.com <ID ключа>

Оба требуемых ключа были установлены и была предпринята попытка установки Monodevelop 4ой версии. Но и тут провал… ей требуется библиотека libc6 более новой версии нежели у меня… ок, сносим мою на её место ставим дебиановскую… сказано, сделано… от это библиотеки зависели почти все пакеты что у меня стояли… «ну да ладно» подумал я и нажал Y… новая библиотека не стала, это было для меня небольшой обидой… «ну да ладно» опять подумал я, и попытался установить предыдущую версию это библиотеки… попытки были безуспешны… «да ладно» подумал я и перезагрузился в рядом стоящий Windows. И снова гугл, и поиск решения…

Акт II. Туда и обратно

Гугл мне показал идентичный сайт убунты со списком пакетов и их описанием в местных репозиториях. Было выяснено что нужная мне библиотека есть в свежем релизе 14.04 LTS… ну ок, скачал, поставил… тормозят окошки, глаз не радуют… ну да ладно. Зная что тут мне так запросто не поставить драйвера, сразу пошел искать сорсы ядра версии 3.2.0, так как точно был уверен что оно работает, всё делалось не в иксах(Ctrl+Alt+(F1-F6)), потому что не перевариваю Unity (или просто не умею готовить)… Как оказалось, по умолчанию у рута нет пароля потому отказалось пускать под эту учётную запись но это поправимо, вернулся в иксы (Ctrl+Alt+F7), открыл терминал и:

sudo passwd root

Указал новый пароль, и всё, всё что нужно готово, но потом подумал, ялро проще скачать таки там где есть копировать вставить, но гитом пользоваться не пришлось, ядро можно скачать в tar архиве здесь (https://www.kernel.org/). Скачал распаковал, и ушел из иксов.
Итак, сорс у нас есть теперь его следует собрать, а перед тем как собрать, сконфигурировать, переместившись в директорию с распакованным ядром пишем:

make menuconfig

Но не сработало, мейк что-то буркнул в ответ, особо не вникая в его ответ сделал повторный выпад:

make config

Ну и всё, конфигурирование началось… Y Y Y Y Y… ответив на полсотни вопросов мне надоело, в итоге зажал Enter тем самым отвечая заданным по умолчанию ответом (он выделяется Заглавной буквой)…
И на этом конфигурирование завершено, теперь запускаем его сборку:

make

Процесс долгий, так что можно пойти поспать. Вскоре ядро собрано, теперь надо собрать модули и установить их:

make modules
make modules_install

Всё прошло почти успешно, была одна ошибка но там был модуль вроде связанный с dvb, ну я вряли буду таким пользоваться на этом железе, так что это я проигнорировал. Теперь дело за малым, установить ядро:

make install

Ядро станет туда куда ему следует (в директорию /boot) и будет запущена автоконфигурация GRUBа. После установки идём на перезагрузку и выбираем пункт с загрузкой ядра 3.2. Система загрузилась и Хсы завелись, теперь дело за малым, откатить иксы, и поставить драйвер. И я снова под рутом, подключил репозиторий, и… фсё… такого пакета нет, сказал мне apt, ну я не растерялся, залез снова в sources.list, и немного подкорректировал данные чтоб apt обратился к разделу precise, посвященный для пользователей 12.04. Через aptitude подсмотрел точную версию пакета иксов и дал задание apt-get установить мне именно его, он предупредил что я что-то делаю не так но я уверил его в том что так и надо, и он начал качать и устанавливать, и естественно всё запорол… попытки поставить нужные мне пакеты apt-get-ом не увенчались успехом, потом вспомнил, aptitude тоже может качать устанавливать и разрешать разногласия. И… да он сделал это, старые иксы были успешно установлены, после чего следовало бы проверить работоспособность, но я решил сразу накатать драйвера. После установки драйверов как всегда перезагрузка… и всё… иксы не заводятся, чтение логов не дало мне подсказок на верное решение, так что я начал бездумно подменять/удалять разные пакеты… В итоге отчаявшись я решил что таки потерплю MonoDevelop старой версии. Установил майю, поставил драйвера.

Акт III. Это не тот гном которого я ожидал

Вернувшись в майю было решено поставит среду гнома, как никак эта среда мне нравилась… маленькие панельки, compiz, и ещё эффекты compiz… ну и от меня последовало:

sudo apt-get install gnome

Всё скачалось хорошо, но при установке gdm он возмутился что у стоящего mdm есть такие же файлы как и у него, и лежат они там же. Недолго думая удалил mdm:

sudo apt-get remove mdm

А после заново запустил установку гнома, но теперь с флагами force и yes(он спрашивает внести ли изменения в некоторые файлы, и ждёт ответа, а я планировал отойти):

sudo apt-get -fy install gnome

Всё стало, сделал LogOut, и… gdm не запустился, ну следуя древнему обычаю когда что-то не работает, а должно, «выключи и включи», всё заработало, выбрав сессию GNOME, залогинился, и моим глазам предстало то что как оказывается зовётся gnome-shell. Я конечно не ожидал увидеть тот гном который отпечатался у меня в памяти ещё в 2005-2006 году. Но то что я видел значительно отличалось… Покопавшись в интернете были найдены расширения, которые значительно повысили комфортабельность использования оболочки, и в принципе, оно мне понравилось… уж лучше чем юнити…

Акт IV. MonoDevelop-4.0

Не покидая надежды я решил всё таки поставить эту IDE. Было придумано предпринять попытку сбора её из исходников. Конечно они были быстро найдены, ссылка на на них есть на официальном сайте. Попытка установить её была частично успешной, ей для сборки нужен mono компилятор, но он у меня был, потому снова обратился к страничке с описанием пакетов, от туда было выяснено что нужен компилятор 3ей версии, и снова гугл… но гугл указал мне на более просто решение. Был найден репозиторий где уже была собранная в deb пакет нужная мне версия:

deb http://ppa.launchpad.net/ermshiperete/monodevelop/ubuntu precise main

Эта строка было добавлен в списки источников пакетов и затем установлен требуемый ключ. Нужный пакет становится без проблем но есть одно но, запускать monodevelop нужно из консоли:

monodevelop-4.0

картинки в меню не появилось, ну и ладно, зато работает…

+ Небольшой Бонус (BURG)

Перед тем как поставить Убунту были предприняты попытки поставить OSx86, раньше я её себе ставил, но тогда была другая видеокарта… и работало оно без проблем. Но суть не в этом, для запуска макОСи ставился хамелеон для идентификации компьютера как одного из семейства маков, и опять же, он весьма симпатичен, а стандартная конфигурация GRUB просто нервно курит в сторонке, но я знал что можно сделать лучше, и в моих поисках я наткнулся на BURG, и заметка на иностранном языке, по утверждению гугла это индонезийский, но не суть важно, были ссылки на репозитории и мне этого хватало.
Первым шагом у нас поставить сам BURG, и настроит его

sudo add-apt-repository ppa:bean123ch/burg
sudo apt-get install burg burg-themes

Во время установки BURG спросит с какими параметрами запускать ядро, мы указываем:

quiet splash (подсмотрел в конфигурации GRUB)

затем от нас требуется выбрать загрузочный раздел, и всё, считай что BURG стоит. На BURG можно взглянуть и без ребута, достаточно запустить:

sudo burg-emu

Следуя указания внизу изображения загрузчика можно выбрать тему… но как по мне, они не очень, и желания доделывать руками не было, хотелось быстрее с этим закончить. На той же индонезийской страничке предлагают поставить Super Boot Manager, используя который можно поставить ещё графических тем для загрузчика. Он находится в другом репозитории так что продолжаем:

sudo add-apt-repository ppa:ingalex/super-boot-manager
sudo apt-get install super-boot-manager

Поставили, запускаем, он спрашивает пароль рута, потом выбираем язык, русского вроде нет, я выбирал английский, и так всё понятно. Нажимаем Burg-manger, вкладка Themes, и выбираем что понравится, на понравившейся делаем двойной клик мышью, он её скачивает, устанавливает, и настраивает.

P.S.:

Хотелось бы отметить что поначалу я упоминал что после добавления нового репозитория в список и последующей установки из него, нужно обновлять списки доступных пакетов, но позже стал это намеренно упускать, чтобы выработалась привычка это делать. Также в статье упущено множество аспектов, так как они просты и не тривиальны, и граблей там я не встретил.

Автор: megweg

Источник

Поделиться

* - обязательные к заполнению поля